質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.99%

manage.py実行時に出るOperationalErrorについて

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 611

KoheiNoma

score 12

python manage.py migrateやpython manage.py runserver実行時に、django.db.utils.OperationalError: unable to open database fileというエラーが発生し、なかなか原因がわからないので、わかりそうな方教えていただけると幸いです。

開発環境はMacOS Sierra、python3.7、 Django2.2です。

以下エラー文です。

(sutasapo_env) USER-no-MacBook-Air-534:django-to22 noma$ python manage.py migrate
Traceback (most recent call last):
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 217, in ensure_connection
    self.connect()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 195, in connect
    self.connection = self.get_new_connection(conn_params)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/sqlite3/base.py", line 194, in get_new_connection
    conn = Database.connect(**conn_params)
sqlite3.OperationalError: unable to open database file

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "manage.py", line 15, in <module>
    execute_from_command_line(sys.argv)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/__init__.py", line 381, in execute_from_command_line
    utility.execute()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/__init__.py", line 375, in execute
    self.fetch_command(subcommand).run_from_argv(self.argv)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/base.py", line 323, in run_from_argv
    self.execute(*args, **cmd_options)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/base.py", line 364, in execute
    output = self.handle(*args, **options)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/base.py", line 83, in wrapped
    res = handle_func(*args, **kwargs)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/core/management/commands/migrate.py", line 87, in handle
    executor = MigrationExecutor(connection, self.migration_progress_callback)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/migrations/executor.py", line 18, in __init__
    self.loader = MigrationLoader(self.connection)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/migrations/loader.py", line 49, in __init__
    self.build_graph()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/migrations/loader.py", line 212, in build_graph
    self.applied_migrations = recorder.applied_migrations()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/migrations/recorder.py", line 73, in applied_migrations
    if self.has_table():
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/migrations/recorder.py", line 56, in has_table
    return self.Migration._meta.db_table in self.connection.introspection.table_names(self.connection.cursor())
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 256, in cursor
    return self._cursor()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 233, in _cursor
    self.ensure_connection()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 217, in ensure_connection
    self.connect()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 217, in ensure_connection
    self.connect()
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/base/base.py", line 195, in connect
    self.connection = self.get_new_connection(conn_params)
  File "/Users/user/To22/Django/django-to22/sutasapo_env/lib/python3.7/site-packages/django/db/backends/sqlite3/base.py", line 194, in get_new_connection
    conn = Database.connect(**conn_params)
django.db.utils.OperationalError: unable to open database file
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • m.ts10806

    2019/04/21 22:39

    回答依頼をいただいて申し訳ないのですが、Pythonはそもそも専門外なのでご期待には添えません。もう少しPython関係のスコアの高いかたに振っていただけたらと思います。
    ※Web側の考え方であれば可能ではありますが今回は私が対応できそうにないです

    キャンセル

  • KoheiNoma

    2019/04/21 22:42

    mts10806さん、丁寧にお返事ありがとうございます。承知致しました、また何かあればよろしくお願い申し上げます。

    キャンセル

回答 1

checkベストアンサー

+1

データベースファイルを開こうとして失敗しているので、すでにデータベースファイルが存在しているとすればそれに対する読み込み(あるいは書き込み)権限がない、存在していないとすれば作成先ディレクトリに対する書き込み権限がない、といった状況だろうと思います。

こちらが参考になるかもしれません。
https://stackoverflow.com/questions/40959337/django-db-utils-operationalerror-unable-to-open-database-file

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/04/22 12:49

    こちらが参考になりそうかなと思ったのですが、tmpフォルダ内にtemp.dbを作成するという意味なのでしょうか。データベース初心者で理解できず、教えていただけると幸いです。

    https://stackoverflow.com/questions/4636970/sqlite3-operationalerror-unable-to-open-database-file

    キャンセル

  • 2019/04/22 12:49

    あー、/path/to/dir というのは本当にそのままのパスを入力してほしいのではなくて、「db/db.sqlite3」の存在するディレクトリのパスを入力する、という意味なんですよね…。説明不足ですみません。

    要は、プロジェクトディレクトリの中に sqlite のデータベースファイルがあるなら、それへのアクセス権限を noma ユーザに与えてみてはどうか、なければデータベースファイルが作られるであろうディレクトリへの書き込み権限を noma ユーザに与えみてはどうかということです。

    この辺はLinuxの使い方になるので、適当にググるなどして進めてみていただきたいです。

    キャンセル

  • 2019/04/23 09:10

    ご丁寧にお返事ありがとうございます。
    再度アプリを作り直したら、通りましたが折角なのでLinuxについての理解を深めようと思います。

    お付き合いくださりありがとうございました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.99%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる